// Processamento de uma imagem no formato pnm

// Limitaes: o ficheiro pnm deve conter informao no formato ASCII sem cor
// (no khoros deve ser convertida para unsigned int)

// Ler um ficheiro no formato pnm, binarizar a imagem e escrever em ficheiro

import java.util.*;
import java.io.*;

class Imagem {
    int bf[][];    // imagem a processar
    int bf2[][];   // imagem processada
    int Xdim; int Ydim;    // dimenses da imagem
    String txt;
    int marca;

    public void load(String file) {

	try {

	    BufferedReader din = new BufferedReader(new FileReader(file));
	    
	    txt = din.readLine();  System.out.println(txt);
 
	    StringTokenizer st = new StringTokenizer(din.readLine());
	    Xdim = Integer.valueOf(st.nextToken()).intValue();
	    Ydim = Integer.valueOf(st.nextToken()).intValue();
	    System.out.println(Xdim + " " + Ydim);
	     
	    st = new StringTokenizer(din.readLine());
	    marca = Integer.valueOf(st.nextToken()).intValue();
	    System.out.println(marca);

	    bf = new int[Ydim][Xdim];
	    bf2 = new int[Ydim][Xdim];

	    st = new StringTokenizer(din.readLine());
	    for(int y=0; y<Ydim; y++) {        // ler dados da imagem
		for(int x=0; x<Xdim; x++) {
		    //System.out.print(y + " " + x + " ");
		    if (!st.hasMoreTokens()) st = new StringTokenizer(din.readLine());

		    bf[y][x] = Integer.valueOf(st.nextToken()).intValue();
		    //System.out.println(bf[y][x] + " ");
		}
	    }
	    din.close();
	}
	catch(IOException e) { System.out.println(e.getMessage()); }
    }
  
    void save(String file) {

	try {

	    BufferedWriter dout = new BufferedWriter(new FileWriter(file));
	    
	    dout.write(txt + "\n");
	    dout.write(Xdim + " " + Ydim + "\n");
	    dout.write(marca + "\n");

	    for(int y=0; y<Ydim; y++) {        // gravar dados da imagem
		for(int x=0; x<Xdim; x++) {
		    dout.write(bf2[y][x] + " ");
		}
	    }
	    dout.close();
	}
	catch(IOException e) { System.out.println(e.getMessage()); }
    }

  
    public int getXY(int x, int y) { 
     
	if ( x>=0 && x<Xdim && y>=0 && y<Ydim )
	    return( bf[y][x] );
	else return(0);
    } 
 
    public void setXY2(int x, int y,int val) { 
      
	if(x>=0 && x<Xdim && y>=0 && y<Ydim)
	    bf2[y][x] = val;
    }
    
    public void bina(int bin) {
      
	for(int y=0; y<Ydim; y++) {
	    for(int x=0; x<Xdim; x++) {
		if (getXY(x,y)<bin) setXY2(x,y,0);
		else setXY2(x,y,255);
	    }
	}    
    }

    public static void main(String[] arg) {
	if (arg.length!=3){ 
	    System.out.println("Uso: bina img_in img_out binval");
	    System.exit(0);
	}
	System.out.println("in=" + arg[0] + " out=" + arg[1] + " bin=" + arg[2]);
  
	Imagem img = new Imagem();
	img.load(arg[0]);
	System.out.println("Leu");
	img.bina(Integer.valueOf(arg[2]).intValue());
	img.save(arg[1]);
	System.out.println("Gravou");

    }
}
